import './index.css';
import nameGenerator from './name-generator';
import isDef from './is-def';
import colorRandom from './randomColor'
import { link } from 'fs';
  
  

// Store/retrieve the name in/from a cookie.

var pos_x,pos_y,mouse_down=false;
//var colorUser=colorRandom();

const cookies = document.cookie.split(';');
let wsname = cookies.find(function(c) {
  if (c.match(/wsname/) !== null) return true;
  return false;
});
if (isDef(wsname)) {
  wsname = wsname.split('=')[1];
} else {
  wsname = nameGenerator();
  document.cookie = "wsname=" + encodeURIComponent(wsname);
  console.log(wsname);
}
let colorUser = cookies.find(function(c) {
  if (c.match(/color/) !== null) return true;
  console.log(c);
  return false;
});
if (colorUser) {
  colorUser = colorUser.split('=')[1].replace('%','#');
} else {
  colorUser = "#"+colorRandom();
  document.cookie = "color=" + encodeURIComponent(colorUser);
  console.log(colorUser);
}

// Set the name in the header
document.querySelector('header>p').textContent = decodeURIComponent(wsname);

// Create a WebSocket connection to the server
const ws = new WebSocket("ws://" + window.location.host+ "/socket");

// We get notified once connected to the server
ws.onopen = (event) => {
  console.log("We are connected.");
};

// Listen to messages coming from the server. When it happens, create a new <li> and append it to the DOM.
var canvas = document.getElementById('canvas');
let context = canvas.getContext("2d");
//context.fillRect(10, 10, 15,15);

////////////////////////////////////////////////////////////

function getMousePos(canvas, evt) {
  var rect = canvas.getBoundingClientRect();
  pos_x=evt.clientX - rect.left;
  pos_y=evt.clientY - rect.top;
  /*return {
    x: evt.clientX - rect.left,
    y: evt.clientY - rect.top
  };*/
}
canvas.addEventListener('mousemove', function(evt) {
  var mousePos = getMousePos(canvas, evt);
 if(mouse_down){
  sendMessage(evt);  
 }
}, false);
canvas.addEventListener('mousedown', function(e) {
  mouse_down=true;
},false);
canvas.addEventListener('mouseup', function(e) { 
  mouse_down=false;
},false);

//////////////////////////////////////////////////////////////////////////////////
//let line;
ws.onmessage = (event) => {
  //console.log(event.data);
  var data = JSON.parse(event.data);
  //var data=event.data;
  console.log(data);

  var name=data.name;
  var color=data.color;
  var X_Y=data.points.slice(1,-1).split(',');
  console.log("points === "+X_Y)
  //for ()
  if(X_Y){
    context.beginPath();
    context.fillStyle=color;
    context.fillRect(X_Y[0],X_Y[1],5,5);
    context.stroke();
  }
  const clientList = document.getElementById("AllConnectedCliens");
  let clientName;
  let linkelement;
  let AlreadyExist = false;
  clientName = document.createElement("li");
  linkelement = document.createElement("a");
  let LiList = clientList.getElementsByTagName("li");
  for (var i = 0; i < LiList.length; i++) {
    if (LiList[i].textContent === decodeURI(name)) {
      AlreadyExist = true;
    }
  }
  if (!AlreadyExist) {
    linkelement.textContent = decodeURI(name);
    linkelement.setAttribute("id",name);
    linkelement.setAttribute("href","");
    linkelement.addEventListener("click", function(e) {
      //context.clearRect(0, 0, canvas.width, canvas.height);
      //console.log(e);
      var tosend = {
        name:e.target.id,
        color:false,
        points:"["+" "+"]"
      }
      sendClient(e,JSON.stringify(tosend));
    });
    clientName.appendChild(linkelement);
    //console.log(clientName);
    clientList.appendChild(clientName);
  }
  //messages.appendChild(line);
};

// Retrieve the input element. Add listeners in order to send the content of the input when the "return" key is pressed.
function sendMessage(event) {
  event.preventDefault();
  event.stopPropagation();
  //console.log(colorUser);
  var toSend = {
      name: wsname,
      color:colorUser,
      points:"["+pos_x+","+pos_y+"]"
  } 
  console.log(JSON.stringify(toSend))
  //ws.send(wsname+"="+colorUser+"="+pos_x+";"+pos_y);
  ws.send(JSON.stringify(toSend));
}

function sendClient(event,obj) {
  event.preventDefault();
  event.stopPropagation();
  ws.send(obj);
}
const clear = document.querySelector("#clear");
clear.addEventListener("click", function(e) {
  context.clearRect(0, 0, canvas.width, canvas.height);
  //console.log(e);
  sendMessage(e);
});